window.watchface = {};
var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var stepCount = 0;
var previousDate = 0
window.watchface.imgRingpng = new Image();
    window.watchface.imgRingpng.src = "Ring.png";
window.watchface.imgBGCleanpng = new Image();
    window.watchface.imgBGCleanpng.src = "BGClean.png";

var Background2ButtonArea = [0, 0, 360, 360];
var Background2ButtonIndex = 0;
var Background2ButtonImage = ["BGClean.png"];
window.watchface.imgBGCleanpng = new Image();
    window.watchface.imgBGCleanpng.src = "BGClean.png";
window.watchface.imgStundenpng = new Image();
    window.watchface.imgStundenpng.src = "Stunden.png";
window.watchface.imgMinutenpng = new Image();
    window.watchface.imgMinutenpng.src = "Minuten.png";
window.watchface.imgSekundenpng = new Image();
    window.watchface.imgSekundenpng.src = "Sekunden.png";

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    if (previousDate === 0) previousDate = date;
    if (previousDate != date) {
        previousDate = date;
        //webapi.pedometer.prevSteps = webapi.pedometer.steps;
        //webapi.pedometer.steps = 0;
    }
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    angle = (-12.000000 + ((348.000000 - -12.000000) * ((date.getDate() - 0.000000) / (31.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgRingpng, -180, -180, 360, 360);
    context.restore();
    context.save();

    context.drawImage(window.watchface.imgBGCleanpng, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "BAT";
    context.fillText(text, 121, 133);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "HR";
    context.fillText(text, 234, 133);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Text";
    context.fillText(text, 234, 151);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Text";
    context.fillText(text, 118, 151);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Steps";
    context.fillText(text, 121, 183);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Dist";
    context.fillText(text, 237, 183);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Text";
    context.fillText(text, 121, 203);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Text";
    context.fillText(text, 235, 202);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Text";
    context.fillText(text, 119, 151);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "BAT";
    context.fillText(text, 122, 133);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Text";
    context.fillText(text, 236, 151);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "HR";
    context.fillText(text, 235, 133);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Text";
    context.fillText(text, 122, 203);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Steps";
    context.fillText(text, 122, 183);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Text";
    context.fillText(text, 237, 202);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px autodigital";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#9C7138";
    text = "Dist";
    context.fillText(text, 238, 183);
    context.restore();
    context.save();

    gImage.src = '' + Background2ButtonImage[Background2ButtonIndex];
    context.drawImage(window.watchface.imgBGCleanpng, 0, 0, 360, 360);
    context.restore();
    context.save();

    angle = (359.000000 + ((1079.000000 - 359.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 181);
    context.rotate(angle);
    context.drawImage(window.watchface.imgStundenpng, -182, -182, 360, 360);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(181, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgMinutenpng, -183, -178, 360, 360);
    context.restore();
    context.save();

    angle = (359.000000 + ((719.000000 - 359.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    context.drawImage(window.watchface.imgSekundenpng, -181, -175, 358, 359);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

    window.addEventListener('touchstart', function (e) {
        if (e.changedTouches[0].clientX >= Background2ButtonArea[0] && e.changedTouches[0].clientX < Background2ButtonArea[2] && e.changedTouches[0].clientY >= Background2ButtonArea[1] && e.changedTouches[0].clientY < Background2ButtonArea[3]) {
            Background2ButtonIndex++;
            if (Background2ButtonIndex >= Background2ButtonImage.length) {
                Background2ButtonIndex = 0;
            }
        }
    });
};
